-- Contributed by Dave Brock
-- minor simplification by Rob Craig

include sort.e

--The following library adds the 'sequence' tools of:


-- remove            removes any element of a sequence
-- remove_first      removes the first element of a sequence
-- remove_last       removes the last element of a sequence
-- insert_between    adds element between two elements of a sequence


-- to the functions already available (built in)  which are:


-- length            returns the length of a sequence
-- repeat            returns a sequence of duplicates
-- append            adds element to the end of a sequence
-- prepend           adds element to the begining of a sequence



global function remove( sequence s,atom pos)
       atom len
       len=length(s)
       -- Editor's Note: (Rob Craig)
       -- Euphoria is more elegant than you think Dave. 
       -- Special case code for pos=1 and pos=len is not necessary:
       
       -- if pos =1 then
       --      s = s[2..len]
       -- elsif pos =len then
       --      s=s[1..len-1]
       -- else 
	       s = s[1..pos-1] & s[pos+1..len]  -- works for any pos
       -- end if
       return s
end function 



global function remove_first( sequence s)
       atom len
       len=length(s)
       s = s[2..len]
       return s
end function 



global function remove_last( sequence s)
       atom len
       len=length(s)
       s=s[1..len-1]
       return s
end function 



global function insert_between (sequence s,sequence si,atom pos1,atom pos2)
       atom len
       len=length(s)
       s = s[1..pos1] & si & s[pos2..len] 
       return s
end function


